	list p=16c84, f=inhx8m 
	include "reg84.asm"
	include "tabele.asm"

;Ŀ
; interni RAM (registar FLAG ima definisane bitove)                         
; registri pocev od DAN zakljucno sa MINB treba da ostanu sa istim redosledom
;


djnz	equ	0ch	; brojac za petlje
flag	equ	0dh	; flag registar

key1on	equ	0	; flag,0=1 kad je levi taster verifikovano pritisnut
key2on	equ	1	; flag,1=1 kad je desni taster verifikovano pritisnut
led5x	equ	2	; flag,2=1 kad led 57,58,59 treba da bude upaljen
bioint	equ	3	; flag,3=1 kad je bio parni interapt 
light	equ	4	; flag,4=1 kad nije pobudjen fototranzistor (in=hi)

;x2	equ	3	; za delitelj sa 2 u interaptu

rotor	equ	0eh	; za shift out
glbro	equ	0fh	; glavni brojac anoda, 0...6, prvo gornji (levi) red

dan	equ	10h	; dan u nedelji,       0...6 vezano 
sat10	equ	11h	; 10 sati              0...5        
sat10b	equ	12h	; 10 sati za budilnik  0...5        
sat	equ	13h	; sat                  0...9        
satb	equ	14h	; sat za budilnik      0...9        
min10	equ	15h	; 10 minuta            0...5        
min10b	equ	16h	; 10 min za budilnik   0...5        
min	equ	17h	; minut                0...9        
minb	equ	18h	; minut za budilnik    0...9 vezano 

sec	equ	19h	; sekund               0...59

debo1	equ	1ah	; rotor za debouncing za levi taster
debo2	equ	1bh	; rotor za debouncing za desni taster

arith	equ	1ch	; aritmeticki registar
scratch	equ	1dh	; scratchpad

freerun	equ	1eh	; delitelj za sek 0...255, bit 7 se koristi za blinker
delit2	equ	1fh	; delitelj 2 za sekunde 0...244

adjust	equ	20h	; 00h = normalan rad sata, bitovi 0-4 za podesavanje:
			; bit 0,1,2,3,4 = podesava se dan,10h,h,10min,min sata
adjustb	equ	21h	; 00h = budilnik off, bitovi 0-4: bit 0 set = on
			; bit 1,2,3,4 = podesava se 10h,h,10min,min budjenja
extra	equ	22h	; za fino stelovanje sata, 33.75 krugova po minutu
xtracou	equ	23h	; brojac do 4 da bi se od 33-34-34-34 dobilo 33.75
intcou	equ	24h	; za delitelj sa 2 u interaptu

temp1	equ	25h	; interrupt reg stack
temp2	equ	26h	; interrupt reg stack

beep	equ	27h	; countdown za alarm, svira ako je >0
frotor	equ	28h	; rotor za ulaz sa fototranzistora

;							; Inicijalizacija                                                           
;Ŀ
; setuje interapt za tmr0, sa preskalerom 1:2, portove, brise ram           
;

start
clram
	clrf	indf		; brise ceo interni RAM
	incf	fsr,same
	btfsc	fsr,5
	btfss	fsr,4
	goto	clram

	bsf	status,rp0
	movlw	80h		; prescaler 1:2 to rtcc, no pullups
	movwf	reg_option
	movlw	03h		; port a: bits 0,1 inputs
	movwf	trisa
	bcf	status,rp0

	movlw	0a0h
	movwf	intcon		; set GIE and T0IE
;							; glbro 13 t
;Ŀ
; opsluzuje dekoder 74hc138, aktivira izlazni paralelni reg 4094            
; uvecava glavni brojac (glbro) u opsegu 0...6                              
;
farm
	clrwdt
	bcf	flag,bioint
	movlw	7
	iorwf	portb,same	; 111 na adr 138 (disable display) *******

	bsf	portb,4		; poz impuls na rck (set 4094 outputs) *******
	bcf	portb,4

	movf	glbro,w
	iorlw	0f8h
	andwf	portb,same	; new address for 138 (enable display) *******

	incf	glbro,same	; advance glbro
	movf	glbro,w
	andlw	7
	xorlw	7
	btfsc	status,z
	clrf	glbro		; wrap (if glbro = 7 then glbro = 0)
;							; dan u nedelji
;Ŀ
; Puni shift reg 4094 sa 15 bitova za prva tri displeja, dan u nedelji      
;

	btfsc	adjust,0
	btfsc	freerun,7	; blinker
	goto	radidun
				; blinkuje dan u nedelji (trenutno off)
	clrf	rotor
	call	out5		; izbacuje prazne bitove (dan u ned off)
	clrf	rotor
	call	out5
	clrf	rotor
	call	out5
	goto	nemadun	
radidun
	movf	dan,w
	movwf	arith		; dan ---> arith

	clrf	pclath		; jer je chargen za dan 0-3 u nedelji na page0
	btfss	dan,2		; ako je dan > 3
	goto	danlth4

	movlw	1
	movwf	pclath		; jer je chargen za dan 4-6 u nedelji na page1
	bcf	arith,2		; svodi dan 4,5,6 na 0,1,2
danlth4
	movf	arith,w
	bcf	status,c
	rlf	arith,same	; arith = dan * 2
	rlf	arith,same	; arith = dan * 4
	addwf	arith,w		; w = dan * 5
	rlf	arith,same	; arith = dan * 8
	rlf	arith,same	; arith = dan * 16
	addwf	arith,same	; arith = dan * 21

	movlw	danuned		; preskace tabelu za cifre
	addwf	arith,same	; arith = dan * 21 + 140

	movf	glbro,w
	addwf	arith,same	; arith = dan * 21 + glbro
	movf	arith,w		; tu je pozicija bajta u danu (1.slovo)

	call	out5bits	; 1. slovo dana u nedelji

	movf	arith,w
	addlw	.7
	call	out5bits	; 2. slovo dana u nedelji

	movf	arith,w
	addlw	.14
	call	out5bits	; 3. slovo dana u nedelji
nemadun
;							; cifre hh:mm
;Ŀ
; Puni shift reg 4094 sa 40 bitova za 4 velike cifre, hh:mm                 
;

	clrw			; svetlo: normalne cifre
	btfsc	flag,light
	movlw	1		; mrak: lude cifre
	movwf	pclath		; chargen za cifre 7x10 na page1 ili page 2

	movlw	0ffh		; 0ffh = blank cifra
	btfsc	adjust,1
	btfsc	freerun,7	; blinker
	movf	sat10,w
	call	outcif		; 10 sati

	movlw	0ffh		; 0ffh = blank cifra
	btfsc	adjust,2
	btfsc	freerun,7	; blinker
	movf	sat,w
	call	outcif		; sat

	movlw	0ffh		; 0ffh = blank cifra
	btfsc	adjust,3
	btfsc	freerun,7	; blinker
	movf	min10,w
	call	outcif		; 10 min

	movlw	0ffh		; 0ffh = blank cifra
	btfsc	adjust,4
	btfsc	freerun,7	; blinker
	movf	min,w
	call	outcif		; minut

;							; sekunde
;Ŀ
; puni shift reg 4094 sa 8 bitova za ledove koji pokazuju sekunde           
; za poslednja 3 leda (57,58,59) ako je glbro=4,5,6 samo pali fleg led5x    
;

	clrf	pclath		; jer je tabela za bitove na page0
	clrf	scratch
	bcf	flag,led5x

	movf	glbro,w
	movwf	djnz
	incf	djnz,same

	decf	djnz,same
	bz	case0		; upravo pokazuje ledove 0...7

	decf	djnz,same
	bz	case8		; upravo pokazuje ledove 8...15

	decf	djnz,same
	bz	case16		; upravo pokazuje ledove 16...23

	decf	djnz,same
	bz	case24		; upravo pokazuje ledove 24...31

	decf	djnz,same
	bz	case32		; upravo pokazuje ledove 32...39

	decf	djnz,same
	bz	case40		; upravo pokazuje ledove 40...47

	goto	case48		; upravo pokazuje ledove 48...55
case0
	movf	sec,w
	addlw	-09h
	goto	secout
case8
	movf	sec,w
	sublw	.10
	movlw	0
	btfss	status,c	; ne pali led 10 ako je sec < 10
	movlw	40h
	movwf	scratch
	movf	sec,w
	addlw	-11h
	goto	secout
case16
	movf	sec,w
	sublw	.20
	movlw	0
	btfss	status,c	; ne pali led 20 ako je sec < 20
	movlw	10h
	movwf	scratch
	movf	sec,w
	addlw	-19h
	goto	secout
case24
	movf	sec,w
	sublw	.30
	movlw	0
	btfss	status,c	; ne pali led 30 ako je sec < 30
	movlw	04h
	movwf	scratch
	movf	sec,w
	addlw	-21h
	goto	secout
case32
	movf	sec,w
	sublw	.57
	btfsc	status,z
	bsf	flag,led5x	; if sec = 57

	movf	sec,w
	sublw	.40
	movlw	0
	btfss	status,c	; ne pali led 40 ako je sec < 40
	movlw	01h
	movwf	scratch
	movf	sec,w
	addlw	-29h
	goto	secout
case40
	movf	sec,w
	sublw	.58
	btfsc	status,z
	bsf	flag,led5x	; if sec = 58

	movf	sec,w
	addlw	-31h
	goto	secout
case48
	movf	sec,w
	sublw	.59
	btfsc	status,z
	bsf	flag,led5x	; if sec = 59

	movf	sec,w
	sublw	.50
	movlw	0
	btfss	status,c	; ne pali led 50 ako je sec < 50
	movlw	40h
	movwf	scratch
	movf	sec,w
	addlw	-39h
secout
	addlw	08h
	btfss	status,c
	goto	zeroout		; if c reset (not in range)
	addlw	bittab		; preskace char gen za cifre i dane
	call	pclsub		; jump on w
	goto	xout
zeroout
	movlw	0
xout
	iorwf	scratch,w	; u scratch je bit celih desetica
	movwf	rotor
	call	out5		; 38t
	call	out3		; 22t
;							; male 7-seg cifre
;Ŀ
; Puni shift reg 4094 sa 15 bitova za prva tri displeja, dan u nedelji      
;
	btfsc	glbro,2
	goto	testkbd		; za vreme ciklusa 4,5,6 testira kbd

	btfss	adjustb,0
	goto	testkbd		; ne pokazuje male cifre ako je budilnik off

	bcf	portb,7
	bsf	portb,3
	bcf	portb,3		; osmi impuls (zapravo prvi)

	clrf	pclath		; jer je chargen za 7-seg cifre na page0

	movf	glbro,w
	movwf	djnz
	incf	djnz,same
	movlw	0ffh		; 0ffh = blankirana cifra

	decf	djnz,same
	bnz	sevs0		; jer nije glbro = 0, prva cifra
	btfsc	adjustb,1
	btfsc	freerun,7	; blinker
	movf	sat10b,w	; glbro=0, mali disp 1.cifra
sevs0
	decf	djnz,same
	bnz	sevs1		; jer nije glbro = 1, druga cifra
	btfsc	adjustb,2
	btfsc	freerun,7	; blinker
	movf	satb,w		; glbro=1, mali disp 2.cifra
sevs1
	decf	djnz,same
	bnz	sevs2		; jer nije glbro = 2, treca cifra
	btfsc	adjustb,3
	btfsc	freerun,7	; blinker
	movf	min10b,w	; glbro=2, mali disp 3.cifra
sevs2
	decf	djnz,same
	bnz	sevs3		; jer nije glbro = 3, cetvrta cifra
	btfsc	adjustb,4
	btfsc	freerun,7	; blinker
	movf	minb,w		; glbro=3, mali disp 4.cifra
sevs3
	addlw	sevseg+1	; preskace char gen za velike cifre i dane
	call	out5bits
	call	out2
	goto	nokbd2
;							; tastatura
;Ŀ
; najpre puni shift reg 4094 jednim bitom za poslednja 3 leda (57,58,59     
; testira tastere i poziva prit1 i prit2 ako je neki upravo pritisnut       
; portb izlaze definise kao ulaze (hi-imp) kad nema napajanja               
;

testkbd
	bcf	portb,7
	btfsc	flag,led5x
	bsf	portb,7
	bsf	portb,3
	bcf	portb,3		; pali-gasi led 57,58,59
	
	movlw	7
	movwf	djnz
clock7
	bcf	portb,7
	bsf	portb,3
	bcf	portb,3		; 7 impulsa sck (jer nisu radile 7-seg cifre)

	decfsz	djnz,same
	goto	clock7

	movf	freerun,w
	andlw	3
	bz	nokbd		; ne radi kad je freerun deljiv sa 4
				; da bi ostavio vremena za counter sata
	bcf	status,c
	btfsc	portb,6		; test tastera 1
	bsf	status,c
	rlf	debo1,same	; stanje tastera u debo1
	incf	debo1,same
	btfss	status,z
	goto	k1nprit		; skok ako k1 nije verif prit

	btfsc	flag,key1on
	goto	k1nprit
				; ovde je key1 upravo pritisnut
	bsf	flag,key1on

	call	prit1		; upravo pritisnut levi taster
k1nprit
	decf	debo1,same	; restore debo1
	btfsc	status,z
	bcf	flag,key1on	; res flag ako je k1 verif otpusten

;-------------------------------- sledi test tastera 2

	bcf	status,c
	btfsc	portb,5		; test tastera 2
	bsf	status,c
	rlf	debo2,same	; stanje tastera u debo2
	incf	debo2,same
	bnz	k2nprit		; skok ako k2 nije verif prit

	btfsc	flag,key2on
	goto	k2nprit
				; ovde je key2 upravo pritisnut
	bsf	flag,key2on

	call	prit2		; upravo pritisnut desni taster
k2nprit
	decf	debo2,same	; restore debo2
	btfsc	status,z
	bcf	flag,key2on	; res flag ako je k2 verif otpusten
nokbd

	movlw	0ffh		; svi portb ulazi kad nema struje
	btfss	porta,0
	movlw	60h		; port b: bits 5,6 inputs kad ima struje
	bsf	status,rp0
	movwf	trisb
	bcf	status,rp0

nokbd2
;							; brojac sata
;Ŀ
; ovuda prodje 1M / 1024 = 976.5625 puta u sekundi                          
; dakle perioda prolaska je 1.024 ms                                        
; uvecava brojace freerun (/4) delit2 (/244) sec (/60) min (/10) min10 (/6) 
;   sat (/10) i sat10 (do 24 sata)                                          
; na 10 minuta ubacuje extra cikluse, zavisno od sadrzine code addr 0001    
; na pun sekund ubacuje stanje fototranz u rotor, ako je 8x isto, flag light
; umanjuje stanje beep ako je >0 (to je za alarm)                           
;

	decf	extra,same	; if extra>0 then dec extra and skip tictac
	btfss	extra,7
	goto	notesta		; ako je extra bio veci od 0 (fini stelung)
	clrf	extra		; restore old value (0) of extra ako je bio =0

	incf	freerun,same
	clrw
	iorwf	adjust,same
	btfss	status,z
	goto	gotovo2		; jer ne radi sat i gasi alarm dok se podesava

	movf	freerun,w
	andlw	3
	btfss	status,z
	goto	notesta
				; dalje ide samo ako je freerun deljiv sa 4
	incf	delit2,same
	movlw	.244
	subwf	delit2,w	; w = delit2 - 244, c set if overflow
	bnz	notesta		; not overflow
	clrf	delit2
				; dalje ide u svakom 976. krugu (1 sec)
	btfsc	sec,0
	incf	extra,same	; povecava /976 na /976.5 (977 svake druge sek)

				; ---- pun sekund: debouncer fototranzistora
	bcf	status,c
	btfsc	porta,1		; ulaz sa fototranzistora
	bsf	status,c
	rlf	frotor,same	; stanje tastera u debo1
	incf	frotor,same
	btfsc	status,z
	bsf	flag,light	; set light if verif hi
	decf	frotor,same
	btfsc	status,z
	bcf	flag,light	; reset light if verif lo

				; ---- pun sekund: decif beep
	btfss	sec,0
	goto	sec2		; da bi decif bio na svake 2 sekunde
	movf	beep,same
	btfss	status,z
	decf	beep,same	; if beep>0 then decf beep
sec2
				; ----
	incf	sec,same
	movlw	.60
	subwf	sec,w		; w = sec - 60, c set if overflow
	btfss	status,c
	goto	notesta		; not overflow
	clrf	sec
				; ---- minut: dodati jos 33,34,34,34 takta
	incf	min,same
	movlw	.10
	subwf	min,w		; w = min - 10, c set if overflow
	btfss	status,c
	goto	notictac		; not overflow
	clrf	min

				; ---- f i n o   s t e l o v a n j e :
				;
				;      10 minuta: svaki extra krug ovde
				;      usporava za po 0.147456 sec na dan
				;      (a sat vec zuri 5.53 sec, dakle nulti
				;      stelung je na 37 extra krugova ovde)
				;      pazi: broj > 37 znaci da sat sporije
				;      radi, a broj < 37 da brze radi


	movlw	const		; to je adresa na kojoj je konstanta
	call	pclsub		; jump on w
	movwf	extra		; fino stelovanje

				; ----
	incf	min10,same
	movlw	.6
	subwf	min10,w		; w = min10 - 6, c set if overflow
	btfss	status,c
	goto	notictac	; not overflow
	clrf	min10

	incf	sat,same
	movlw	.10
	subwf	sat,w		; w = sat - 10, c set if overflow
	btfss	status,c
	goto	nyetsat		; not overflow
	clrf	sat
	incf	sat10,same
	goto	notictac
nyetsat
	call	test24
	btfss	status,c
	goto	notictac
	clrf	sat10

	incf	dan,same
	movlw	.7
	subwf	dan,w		; w = dan - 7, c set if overflow
	btfsc	status,c
	clrf	dan		; overflow
notictac

;							; test vreme budjenja
;Ŀ
; poredi sat sa registrom budilnika, ako je = onda set beep to 239 (8minuta)
;

	decf	adjustb,w
	bnz	notesta		; jer je budilnik off ili se podesava

	movf	sat10,w
	movwf	djnz
	movf	sat10b,w
	subwf	djnz,same	; djnz = 0 ako je dosada sve bilo isto

	movf	sat,w
	movwf	arith
	movf	satb,w
	subwf	arith,w
	iorwf	djnz,same	; djnz = 0 ako je dosada sve bilo isto

	movf	min10,w
	movwf	arith
	movf	min10b,w
	subwf	arith,w
	iorwf	djnz,same	; djnz = 0 ako je dosada sve bilo isto

	movf	min,w
	movwf	arith
	movf	minb,w
	subwf	arith,w
	iorwf	djnz,same	; djnz = 0 ako je dosada sve bilo isto

	movlw	.239		; za 8 minuta svirke
	btfsc	status,z
gotovo2
	movwf	beep
notesta
;							; sinhronizacija
;Ŀ
; ceka da nastupi interapt i onda se vraca na farm                          
;

sync
	btfss	flag,bioint
	goto	sync
	goto	farm

;							; graf sabrutine
;Ŀ
; sabrutine za punjenje shift registra                                      
;

;-------------------------------- izbacuje 10 bita ka shift reg, cifre 7x10

outcif				; na ulazu cifra u w
				; pclah = 1 (tabela za cifru)
				; total 89t sa pozivom
	addlw	.1
	btfss	status,z
	goto	pokaz
	clrf	rotor
	call	out5
	clrf	rotor
	goto	out5
pokaz
	addlw	-1
	bcf	status,c
	movwf	arith
	rlf	arith,same	; arith = cifra * 2
	movf	arith,w		; w = cifra * 2
	rlf	arith,same	; arith = cifra * 4
	addwf	arith,w		; w = cifra * 6
	rlf	arith,same	; arith = cifra * 8
	addlw	cifre
	addwf	arith,same	; arith = cifra * 14 + 5
		
	movf	glbro,w
	addwf	arith,same
	addwf	arith,same	; arith = cifra * 14 + glbro * 2
	movf	arith,w		; tu je pozic bajta u cifri

	call	out5bits	; cifra (gornjih 5 tacaka)

	movf	arith,w
	addlw	1
				; dalje sledi out5bits, to je donjih 5 tacaka

;-------------------------------- izbacuje 5 bita ka shift reg, dan u nedelji

out5bits			; na ulazu pclath = 0 ili 1
				; w pokazuje na poziciju u tabeli
				; izbacuje bitove 0...4 iz tabele ka 4094
				; salje impuls na sck (portb,3)
				; total 38t sa pozivom (optimizovan za brzinu)

	call	pclsub		; jump on w
	movwf	rotor
out5
	bcf	portb,7		; reset data out pin
	rrf	rotor,same	; bit 0 first, bit 4 last
	btfsc	status,c	; skip if rotor bit = 0
	bsf	portb,7		; set data out pin if rotor bit = 1
	bsf	portb,3
	bcf	portb,3		; impuls na sck

	bcf	portb,7
	rrf	rotor,same	; bit 1
	btfsc	status,c
	bsf	portb,7
	bsf	portb,3
	bcf	portb,3
out3
	bcf	portb,7
	rrf	rotor,same	; bit 2
	btfsc	status,c
	bsf	portb,7
	bsf	portb,3
	bcf	portb,3

	goto	out2

;							; komande sa tastera
;Ŀ
; prit1 i prit2 poziva samo ako je upravo pritisnut taster                  
;

prit1
	btfsc	porta,0
	return			; ne radi levi taster kad nema struje

	btfsc	adjustb,0
	goto	imabud
				; iskljucen budilnik, dakle podesava sat
	incf	adjust,same
	decf	adjust,same
	btfsc	status,z
	goto	adjbio0
	bcf	status,c
	rlf	adjust,same	; advance adjust status
	movlw	1fh
	andwf	adjust,same	; clrf adjust ako je bit 4 bio setovan
	return
adjbio0
	incf	adjust,same	; adjust bio 0, sad je 1
	return
imabud				; ukljucen budilnik, dakle podesava budilnik
	clrw
	iorwf	beep,same
	btfss	status,z
	return			; dok traje alarm, ignorise taster 1

	bcf	adjustb,0	; privremeno gasi bit 0 radi rotiranja

	incf	adjustb,same
	decf	adjustb,same
	btfsc	status,z
	goto	abbio0		; if no adjustb flags set

	bcf	status,c
	rlf	adjustb,same	; advance adjustb status
	movlw	1fh
	andwf	adjustb,same	; clrf adjustb ako je bit 4 bio setovan
	bsf	adjustb,0	; restore bit 0
	return

abbio0
	incf	adjustb,same
	incf	adjustb,same	; adjustb je bio 0, sad je bit 1 set
	bsf	adjustb,0	; restore bit 0
	return


; -------------------------------

prit2
	movf	adjustb,w
	andlw	1eh		; tu su samo flegovi za podesavanje budilnika
	iorwf	adjust,w	; ...a ovde flegovi za podesavanje sata
	btfsc	status,z	; ako se ista podesava (blinkuje)...

	goto	onoff		; ode da pali-gasi flag za budilnik on-off
				; ...prvo da vidi sta se podesava
	btfsc	porta,0
	return			; ne radi kad nema struje

	movlw	minb
	btfsc	adjust,0
	movlw	dan
	btfsc	adjust,1
	movlw	sat10
	btfsc	adjustb,1
	movlw	sat10b
	btfsc	adjust,2
	movlw	sat
	btfsc	adjustb,2
	movlw	satb
	btfsc	adjust,3
	movlw	min10
	btfsc	adjustb,3
	movlw	min10b
	btfsc	adjust,4
	movlw	min

	movwf	fsr		; stelovace ga u ind addr modu
	clrf	pclath
	incf	pclath,same	; jer je overflow tabela na page 1
	addlw	ovftab-dan-100h
	call	pclsub		; jump on w
	clrf	pclath		; jer je overflow tabela na page 0
				; sad je ovf value u w
	incf	indf,same	; uvecanje cifre
	addwf	indf,w		; nova (uvecana) vrednost + ovf test value
	btfsc	status,c
	clrf	indf		; wrap adjusted value to 00h if ovf
test24
	movf	sat10,w		; jos da eliminise mogucnost da je sat>23...
	movwf	djnz
	bcf	status,c
	rlf	djnz,same
	rlf	djnz,same
	rlf	djnz,same
	rlf	djnz,same
	movf	sat,w
	addwf	djnz,w		; w = sat10 * 16 + sat
	addlw	-24h
	btfss	status,c
	goto	not24		; not overflow
	clrf	sat
not24
	return			; c set if adjusted, nc if <24

;--------------------------------

onoff				; znaci nista se ne podesava; onda...
	movf	adjustb,w
	xorlw	.1
	movwf	adjustb

	btfsc	porta,0
	bcf	adjustb,0	; ...gasi flag za budilnik kad nema struje

	clrf	beep		; ...i gasi alarm
	return

;							; interrupt
;Ŀ
; ovde skace sa 0004 (tmr0 interrupt) na svakih 512  masinskih ciklusa      
; opsluzuje tonski izlaz budilnika                                          
; deli interapt sa 2, u prvom delu samo gasi tonski izlaz                   
; u drugom delu setuje fleg bioint za sinhronizaciju sata                   
;

inter
	movwf	temp1		; \
	swapf	status,w
	bcf	status,rp0
	movwf	temp2		; \\

	incf	intcou,same
	btfsc	intcou,0
	goto	krug2
				; prvi krug interapta
	movf	porta,w
	iorlw	18h		; hi = ugaseni tonski izlazi
	btfss	intcou,6
	movwf	porta		; gasi tonske izlaze if intcou,6 = 0 (1000 Hz)
	goto	reti

;--------------------------------

krug2				; drugi krug interapta
	bsf	flag,bioint
	movlw	18h
	movf	beep,same	; beep test
	bz	nesvira

	movlw	1ch		; ukljuceno samo off-on pojacalo
	btfsc	intcou,6	; if intcou,6 = 1 then 500 Hz
	btfss	intcou,1
	movlw	04h		; ukljuceno pojacalo i ton

	btfsc	sec,4
	goto	nesvira
	btfss	sec,5
	iorlw	8h		; tih ton prvih 16 sekundi (bit3 hi)
nesvira
	movwf	porta
reti
	bcf	intcon,t0if

	swapf	temp2,w		; //
	movwf	status
	swapf	temp1,same	; /
	swapf	temp1,w
	retfie
;								; ept
;Ŀ
; reset vektor i mapa portova                                               
;

pclsub
	movwf	pcl		; jump on w

	end

; port a bit 0 (ulaz)	=1 kad nema napona
; port a bit 1 (ulaz)	=1 kad ima svetla
; port a bit 2 (izlaz)  ukljucivanje pojacala (1 = ukljuceno)
; port a bit 3 (izlaz)  jaci ton
; port a bit 4 (izlaz)  slabiji ton

; port b bit 0 (izlaz)	dekoder 138 adresa a
; port b bit 1 (izlaz)	dekoder 138 adresa b
; port b bit 2 (izlaz)	dekoder 138 adresa c
; port b bit 3 (izlaz)	serijski takt (sck) za shift reg 4094
; port b bit 4 (izlaz)	register load (rck) za shift reg 4094
; port b bit 5 (ulaz)   =0 kad je desni taster pritisnut
; port b bit 6 (ulaz)   =0 kad je levi taster pritisnut
; port b bit 7 (izlaz)  data out for shift reg 4094
